<template>
  <div class="flex items-center gap-3">
    <svn-pro-slider
      v-model="currentValue"
      :step="10"
      :min="20"
      :max="100"
      class="w-[120px]"
      @update:model-value="handleChange"
    />

    <svn-pro-text
      subtitle-large
      regular
      @click.prevent.self
    >
      {{ currentValue }}%
    </svn-pro-text>
  </div>
</template>

<script setup>
import { debounce } from 'lodash';
import { ref, onMounted, watch } from 'vue';
import SvnProSlider from '../../input/SvnProSlider.vue';
import SvnProText from '../../styles/SvnProText.vue';

const props = defineProps({
  width: { type: String, default: null },
})

onMounted(() => {
  currentValue.value = parseInt(props.width)
})

const emit = defineEmits(['handle-change'])

const currentValue = ref(null);

const handleChange = debounce((value) => {
  const newValue = parseInt(value);
  currentValue.value = newValue;
  emit('handle-change', currentValue.value)
}, 150);

watch(props, (newValue, oldValue) => {
  if (newValue.width) {
    currentValue.value = parseInt(props.width)
  }
})
</script>
